#ifndef _GROUPSCREEN_H
#define _GROUPSCREEN_H 1

#include <vector>
#include <pqxx/connection>
#include <time.h>
#include <sys/time.h>

#include "screen.h"
#include "flagtrigger.h"
#include "group.h"
#include "fonts.h"

/* A screen class showing a group in the tournament */
class GroupScreen : public GenericScreen {
private:
	unsigned tournament, round, parallel, machine, num_machines;
	FlagTrigger scores_changed;
	pqxx::connection &conn;
	bool valid;
	struct timeval last_updated;
	std::vector<TextDefer> last_text;

public:
	GroupScreen(pqxx::connection &conn, unsigned tournament, unsigned round, unsigned parallel, unsigned machine, unsigned num_machines);
	virtual ~GroupScreen();

	bool check_invalidated();
	void draw(unsigned char *buf);
	int get_priority();
};

#endif /* !defined(_GROUPSCREEN_H) */
